VERSION 5.00
Begin VB.UserControl Clock 
   ClientHeight    =   1470
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1845
   FillStyle       =   0  'Solid
   ScaleHeight     =   98
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   123
End
Attribute VB_Name = "Clock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function AngleArc& Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, _
ByVal Y As Long, ByVal dwRadius As Long, ByVal eStartAngle As Single, ByVal _
eSweepAngle As Single)

Private Declare Function MoveToEx& Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, _
ByVal Y As Long, lpPoint As Long)

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'Default Property Values:
Const m_def_Minute = 0
Const m_def_FrameColor = 0
Const m_def_HourHandColor = 0
Const m_def_MinuteHandColor = 0
Const m_def_CenterPieceColor = 0
Const m_def_FaceColor = &HC0C0C0
Const m_def_Hour = 0
Const m_def_Time = 0
'Property Variables:
Dim m_Minute As Long
Dim m_FrameColor As OLE_COLOR
Dim m_HourHandColor As OLE_COLOR
Dim m_MinuteHandColor As OLE_COLOR
Dim m_CenterPieceColor As OLE_COLOR
Dim m_FaceColor As OLE_COLOR

Dim m_Hour As Long
Dim m_Time As Date
'Event Declarations:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."





Private Sub DrawClock()
    
    Dim lXPos As Long
    Dim lYPos As Long
    
    Dim lRadius As Long
    
    Dim sinAngle As Single
    Dim udtPoint As POINTAPI
    
    Dim lngOldColor As Long
    
    Dim lngNewBrush As Long
    Dim lngOldBrush As Long
    
    Dim lReturn As Long
    
    ' Clear the Display
    Cls
    
    ' Save the old color
    lngOldColor = UserControl.ForeColor
    
    ' Figure out the Center
    lXPos = ScaleWidth / 2
    lYPos = ScaleHeight / 2
    
    ' Determine the Best radius
    lRadius = IIf(lXPos > lYPos, lYPos, lXPos)
    
    ' Draw the circle
    UserControl.ForeColor = m_FrameColor
    UserControl.FillColor = m_FaceColor
    ' Draw the outer Circle
    Circle (lXPos, lYPos), lRadius
    
    ' Draw the outer Circle
    Circle (lXPos, lYPos), lRadius
    
    UserControl.ForeColor = m_CenterPieceColor
    ' Draw the Center circle
    Circle (lXPos, lYPos), 4
    
    'Reset the forecolor
    UserControl.ForeColor = lngOldColor
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Draw the Hour Hand
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    
    ' Calculate the Angle to draw
    Select Case m_Hour
        Case 0, 12: sinAngle = -270
        Case 1: sinAngle = -300
        Case 2: sinAngle = -330
        Case 3: sinAngle = 0
        Case 4: sinAngle = -30
        Case 5: sinAngle = -60
        Case 6: sinAngle = -90
        Case 7: sinAngle = -120
        Case 8: sinAngle = -150
        Case 9: sinAngle = -180
        Case 10: sinAngle = -210
        Case 11: sinAngle = -240
    End Select
        
    ' Add in the Extra degress for the minutes
    sinAngle = sinAngle - (m_Minute / 2)
        
    'Create the a solid brush with the new color
    m_HourHandColor = RGB(255, 0, 0)
    lngNewBrush = CreateSolidBrush(m_HourHandColor)
    lngOldBrush = SelectObject(hdc, lngNewBrush)
    
    ' Set the Current X,Y to the Center
    lReturn = MoveToEx(hdc, lXPos, lYPos, 0&)
    ' Draw the Angled line
    lReturn = AngleArc(hdc, lXPos, lYPos, (lRadius / 2), sinAngle, 0)
    
    ' Replace the old brush
    lReturn = SelectObject(hdc, lngOldBrush)
    ' Delete the unneeded brush
    lReturn = DeleteObject(lngNewBrush)
    

    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Draw the Minute Hand
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    
    ' Calculate the Angle to draw, this will place it at the
    ' nearest 5 minute mark
    Select Case (m_Minute \ 5)
        Case 0: sinAngle = -270
        Case 1: sinAngle = -300
        Case 2: sinAngle = -330
        Case 3: sinAngle = -360
        Case 4: sinAngle = -30
        Case 5: sinAngle = -60
        Case 6: sinAngle = -90
        Case 7: sinAngle = -120
        Case 8: sinAngle = -150
        Case 9: sinAngle = -180
        Case 10: sinAngle = -210
        Case 11: sinAngle = -240
    End Select
        
    ' Add in the Extra degress for the minutes
    sinAngle = sinAngle - ((m_Minute Mod 5) * 6)
        
    'Create the a solid brush with the new color
    lngNewBrush = CreateSolidBrush(m_MinuteHandColor)
    lngOldBrush = SelectObject(hdc, lngNewBrush)
    
    ' Set the Current X,Y to the Center
    lReturn = MoveToEx(hdc, lXPos, lYPos, 0&)
    ' Draw the Angled line
    lReturn = AngleArc(hdc, lXPos, lYPos, (lRadius / 4) * 3, sinAngle, 0)
    
    ' Replace the old brush
    lReturn = SelectObject(hdc, lngOldBrush)
    ' Delete the unneeded brush
    lReturn = DeleteObject(lngNewBrush)

End Sub


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    UserControl.Refresh
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub
'
'Public Property Get Minute() As Long
'    Minute = m_Minute
'End Property
'
'Public Property Let Minute(ByVal New_Minute As Long)
'    m_Minute = New_Minute
'    PropertyChanged "Minute"
'End Property

Public Property Get Hour() As Long
Attribute Hour.VB_Description = "Returns/Sets the current hour"
    Hour = m_Hour
End Property

Public Property Let Hour(ByVal New_Hour As Long)
    m_Hour = New_Hour
    PropertyChanged "Hour"
    
    m_Time = Trim$(Str$(m_Hour)) & ":" & Trim$(Str$(m_Minute))
    DrawClock
End Property

Public Property Get Time() As Date
Attribute Time.VB_Description = "Returns/Sets the time to display"
    Time = m_Time
End Property

Public Property Let Time(ByVal New_Time As Date)
    m_Time = New_Time
    PropertyChanged "Time"
    m_Hour = Format(New_Time, "HH")
    m_Minute = Format(New_Time, "MM")
    DrawClock
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    Set Font = Ambient.Font
'    m_Minute = m_def_Minute
    m_Hour = m_def_Hour
    m_Time = m_def_Time
    m_Minute = m_def_Minute
    m_FrameColor = m_def_FrameColor
    m_HourHandColor = m_def_HourHandColor
    m_MinuteHandColor = m_def_MinuteHandColor
    m_CenterPieceColor = m_def_CenterPieceColor
    m_FaceColor = m_def_FaceColor
End Sub

Private Sub UserControl_Paint()
    DrawClock
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
'    m_Minute = PropBag.ReadProperty("Minute", m_def_Minute)
    m_Hour = PropBag.ReadProperty("Hour", m_def_Hour)
    m_Time = PropBag.ReadProperty("Time", m_def_Time)
    m_Minute = PropBag.ReadProperty("Minute", m_def_Minute)
    m_FrameColor = PropBag.ReadProperty("FrameColor", m_def_FrameColor)
    m_HourHandColor = PropBag.ReadProperty("HourHandColor", m_def_HourHandColor)
    m_MinuteHandColor = PropBag.ReadProperty("MinuteHandColor", m_def_MinuteHandColor)
    m_CenterPieceColor = PropBag.ReadProperty("CenterPieceColor", m_def_CenterPieceColor)
    m_FaceColor = PropBag.ReadProperty("FaceColor", m_def_FaceColor)
End Sub

Private Sub UserControl_Resize()
    DrawClock
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
'    Call PropBag.WriteProperty("Minute", m_Minute, m_def_Minute)
    Call PropBag.WriteProperty("Hour", m_Hour, m_def_Hour)
    Call PropBag.WriteProperty("Time", m_Time, m_def_Time)
    Call PropBag.WriteProperty("Minute", m_Minute, m_def_Minute)
    Call PropBag.WriteProperty("FrameColor", m_FrameColor, m_def_FrameColor)
    Call PropBag.WriteProperty("HourHandColor", m_HourHandColor, m_def_HourHandColor)
    Call PropBag.WriteProperty("MinuteHandColor", m_MinuteHandColor, m_def_MinuteHandColor)
    Call PropBag.WriteProperty("CenterPieceColor", m_CenterPieceColor, m_def_CenterPieceColor)
    Call PropBag.WriteProperty("FaceColor", m_FaceColor, m_def_FaceColor)
End Sub

Public Property Get Minute() As Long
Attribute Minute.VB_Description = "Returns/Sets the current minute"
    Minute = m_Minute
End Property

Public Property Let Minute(ByVal New_Minute As Long)
    m_Minute = New_Minute
    PropertyChanged "Minute"
    m_Time = Trim$(Str$(m_Hour)) & ":" & Trim$(Str$(m_Minute))
    DrawClock
End Property

Public Property Get FrameColor() As OLE_COLOR
Attribute FrameColor.VB_Description = "Returns/Sets the color of the frame of the clock"
Attribute FrameColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    FrameColor = m_FrameColor
End Property

Public Property Let FrameColor(ByVal New_FrameColor As OLE_COLOR)
    m_FrameColor = New_FrameColor
    PropertyChanged "FrameColor"
End Property

Public Property Get HourHandColor() As OLE_COLOR
Attribute HourHandColor.VB_Description = "Returns/Sets the color of the hour hand"
Attribute HourHandColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    HourHandColor = m_HourHandColor
End Property

Public Property Let HourHandColor(ByVal New_HourHandColor As OLE_COLOR)
    m_HourHandColor = New_HourHandColor
    PropertyChanged "HourHandColor"
End Property

Public Property Get MinuteHandColor() As OLE_COLOR
Attribute MinuteHandColor.VB_Description = "Returns/Sets the minute hand color"
Attribute MinuteHandColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    MinuteHandColor = m_MinuteHandColor
End Property

Public Property Let MinuteHandColor(ByVal New_MinuteHandColor As OLE_COLOR)
    m_MinuteHandColor = New_MinuteHandColor
    PropertyChanged "MinuteHandColor"
End Property

Public Property Get CenterPieceColor() As OLE_COLOR
Attribute CenterPieceColor.VB_Description = "Retruns/Sets the color of the piece in the middle"
Attribute CenterPieceColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    CenterPieceColor = m_CenterPieceColor
End Property

Public Property Let CenterPieceColor(ByVal New_CenterPieceColor As OLE_COLOR)
    m_CenterPieceColor = New_CenterPieceColor
    PropertyChanged "CenterPieceColor"
End Property

Public Property Get FaceColor() As OLE_COLOR
Attribute FaceColor.VB_Description = "Returns/Sets the color of the face of the clock"
Attribute FaceColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    FaceColor = m_FaceColor
End Property

Public Property Let FaceColor(ByVal New_FaceColor As OLE_COLOR)
    m_FaceColor = New_FaceColor
    PropertyChanged "FaceColor"
End Property

